Bug 152440 - ppc64 arches can crash when single setpping a debugger through syscall return code
Summary: ppc64 arches can crash when single setpping a debugger through syscall return...
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel   
(Show other bugs)
Version: 4.0
Hardware: powerpc
OS: Linux
medium
medium
Target Milestone: ---
: ---
Assignee: Neil Horman
QA Contact: Brian Brock
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: 154907 156322
TreeView+ depends on / blocked
 
Reported: 2005-03-29 15:25 UTC by Neil Horman
Modified: 2007-11-30 22:07 UTC (History)
4 users (show)

Fixed In Version: RHSA-2005-514
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-10-05 12:55:12 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
patch to swap stack restore/RI clear ordering (479 bytes, patch)
2005-03-29 15:25 UTC, Neil Horman
no flags Details | Diff


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2005:514 qe-ready SHIPPED_LIVE Important: Updated kernel packages available for Red Hat Enterprise Linux 4 Update 2 2005-10-05 04:00:00 UTC

Description Neil Horman 2005-03-29 15:25:58 UTC
Description of problem:
ppc64 arches can crash when single setpping a debugger through syscall return
code.  Currently the ppc64 user stack is restored before clearing the RI bit in
the MSR.  Before the RI bit is cleared, traps are allowed, and if one is taken
after the stack is resored, but before the RI bit is cleared, unpredictable and
fatal results (oopses) can occur.

Version-Release number of selected component (if applicable):
all

How reproducible:
always

Steps to Reproduce:
1. Use a hardware/jtag debugger to write software interrupt instructions
(software breakpoints), to the code addresses between the instructions in
entry.S where the user stack is restored and the RI bit is cleared in the
syscall_exit code.

2. execute a syscall in user space.
  
Actual results:
System will crash

Expected results:
Breakpoint is handled, system does not crash

Additional info:

Comment 1 Neil Horman 2005-03-29 15:25:59 UTC
Created attachment 112418 [details]
patch to swap stack restore/RI clear ordering

Comment 2 Neil Horman 2005-03-29 15:26:53 UTC
attached patch has been accepted on rhkernel-list for RHEL4-U2.

Comment 6 Red Hat Bugzilla 2005-10-05 12:55:12 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2005-514.html



Note You need to log in before you can comment on or make changes to this bug.